%{
	#include <string.h>
	#include "tb.h"
	#include "bison_grammar.hpp"	
	int lineNumber = 0;
	int contaChaves = 0;
%}

%x comment_line
%x ignore

%%

[a-zA-Z_][a-zA-Z0-9_]* { yylval.str = strdup(yytext); return IDENTIFIER; }
"%{" {return PC_LBRACE;}
"%}" {return PC_RBRACE;}
"%%" {return DOUBLE_PC;}
":" {return COLON;}
"|" {return PIPE;}
"%" {return PC;}
";" {return SEMICOLON;}
"%token" {return PC_TOKEN;}
\'[^\']\' { yylval.chr = yytext[1]; return CHAR_DEF; }
[ \t\r]  { }
\n { lineNumber++; }


"/*" {
    BEGIN(comment_line);
  }

<comment_line>"*/"  {
    BEGIN(INITIAL);
}

<comment_line>\n  {
    lineNumber++;
}

<comment_line>. {
}

"{" {
    BEGIN(ignore);
	 contaChaves++;
  }

<ignore>"}"  {
	contaChaves--;
	if(contaChaves == 0)
    BEGIN(INITIAL);
}
<ignore>"{"  {
    contaChaves++;
}

<ignore>\n  {
    lineNumber++;
}

<ignore>. {
}


. {printf("ERRO no LEXER! Ignorando %s...\n", yytext);}
%%